
DECLARE SUB ReadDword ()
DECLARE SUB DrawLine ()
DECLARE SUB OutFile ()

COMMON SHARED b1%, b2%, r, dw%, bheight, bwidth, bpen, rest, crlf$

CLS

SCREEN 0

DrawLine
PRINT "           BMP -> QUINDOS file converter"
DrawLine
PRINT " Input file  : BMP file - white background, black lines"
PRINT "                        - saved as 256 colours"
PRINT " Output file : DAT file for DRWDAT command in QUINDOS"
DrawLine
PRINT

INPUT "Enter Bitmap Filename: ", n$
IF n$ = "" THEN GOTO 999

DrawLine
PRINT
PRINT "Bitmap Info"

OPEN n$ FOR BINARY AS #1
 ' Read identification tags B and M
r = 1
ReadDword
PRINT "Identification:  "; CHR$(b2%); CHR$(b1%)
ident = b2%

r = 3
ReadDword
PRINT "Size          : "; dw%; " bytes"

r = 19
ReadDword
PRINT "Width         : "; dw%; " pixels"
bwidth = dw%

r = 23
ReadDword
PRINT "Height        : "; dw%; " pixels"
bheight = dw%

IF ident <> ASC("B") THEN
  DrawLine
  PRINT
  INPUT "This is not valid bitmap file! Press ENTER...", dummy
  GOTO 999
END IF

IF bheight > 479 THEN
  DrawLine
  PRINT
  INPUT "The file is too large - max. Height = 479 ! Press ENTER...", dummy
  GOTO 999
END IF

IF bwidth > 639 THEN
  DrawLine
  PRINT
  INPUT "The file is too large - max. Width = 639 ! Press ENTER...", dummy
  GOTO 999
END IF


DrawLine
PRINT
INPUT "Press ENTER to view the bitmap...", dummy

SCREEN 11

  ' If the width/4 is not entire number
rest = 4 * (bwidth / 4 - FIX(bwidth / 4))
IF rest = 0 THEN rest = 4
  ' address where begin the data
r = 1078
FOR i = 1 TO bheight
   FOR k = 1 TO bwidth
       r = r + 1
       ReadDword
       IF b2% > 0 THEN
          PSET (k, bheight + 1 - i)
       END IF
   NEXT k
     ' Empty cycle if rest > 0
   FOR l = 1 TO (4 - rest)
      r = r + 1
   NEXT l
NEXT i

LOCATE 20, 1

INPUT "Enter QUINDOS File name              :", finam$
IF finam$ = "" THEN
  PRINT "File not converted!"
  GOTO 999
END IF

' crlf$="1" for line ending "CR"+"LF" - NT
' crlf$="0" for line ending "CR" - VMS?
crlf$ = "1"

PRINT "Working... Please wait! "

OPEN finam$ FOR OUTPUT AS #2

bpen = 0
r = 1078
OutFile
PRINT "File converted!"

CLOSE

999 :
INPUT "Press ENTER...", dummy
SYSTEM

SUB DrawLine
FOR r = 1 TO 60
  PRINT CHR$(205);
NEXT r
END SUB

SUB OutFile
FOR i = bheight TO 1 STEP -1
   FOR k = 1 TO bwidth
       r = r + 1
       ReadDword
       IF b2% = 0 THEN
         IF bpen <> -1 THEN
           bpen = -1

           PRINT #2, USING "#####.##"; k;
           PRINT #2, ",";
           PRINT #2, USING "#####.##"; bheight + 1 - i;
           PRINT #2, ",";
           PRINT #2, USING "#####"; 0;
           PRINT #2, CHR$(13);
           IF crlf$ = "1" THEN PRINT #2, CHR$(10);


           PRINT #2, USING "#####.##"; k;
           PRINT #2, ",";
           PRINT #2, USING "#####.##"; bheight + 1 - i;
           PRINT #2, ",";
           PRINT #2, USING "#####"; bpen;
           PRINT #2, CHR$(13);
           IF crlf$ = "1" THEN PRINT #2, CHR$(10);
         END IF
       ELSE
         IF bpen <> 0 THEN
           bpen = 0

           PRINT #2, USING "#####.##"; k;
           PRINT #2, ",";
           PRINT #2, USING "#####.##"; bheight + 1 - i;
           PRINT #2, ",";
           PRINT #2, USING "#####"; -1;
           PRINT #2, CHR$(13);
           IF crlf$ = "1" THEN PRINT #2, CHR$(10);

           PRINT #2, USING "#####.##"; k;
           PRINT #2, ",";
           PRINT #2, USING "#####.##"; bheight + 1 - i;
           PRINT #2, ",";
           PRINT #2, USING "#####"; bpen;
           PRINT #2, CHR$(13);
           IF crlf$ = "1" THEN PRINT #2, CHR$(10);
         END IF
       END IF
   NEXT k
   FOR l = 1 TO (4 - rest)
     r = r + 1
   NEXT l
NEXT i

END SUB

SUB ReadDword
  GET #1, r, dw%
  b1% = dw% / 256
  b2% = dw% - b1% * 256
  IF b2% < 0 THEN b2% = b2% * (-1)
  IF b1% < 0 THEN b1% = b1% * (-1)
END SUB

